
loveframes = require('lib.loveframes')
object = require('main.object')
creator = require('main.creator')
remover = require('main.remover')
require('lib.camera')

function love.load()
    config = {
        width = 1000,
        height = 600,
        title = "Physics Sandbox"
    }

	love.graphics.setBackgroundColor(155, 210, 255)
    love.window.setMode(config.width, config.height, {vsync = false})
    love.window.setTitle(config.title)
   	creator.load()
    mode = "Create"
   	type1 = "dynamic"
   	type2 = "dynamic"
    lk = love.keyboard
    can = true
    cmx = 0
    cmy = 0
end

function love.update(dt)
    loveframes.update(dt)
    creator.update()
    if static1:GetChecked() then
    	type1 = "static"
    else type1 = "dynamic" end
    if static2:GetChecked() then
    	type2 = "static"
    else type2 = "dynamic" end
    object.update(dt)
    if lk.isDown("left") then
        cmx = cmx - 120 * dt
    elseif lk.isDown("right") then
        cmx = cmx + 120 * dt
    end
     if lk.isDown("up") then
        cmy = cmy - 120 * dt
    elseif lk.isDown("down") then
        cmy = cmy + 120 * dt
    end
    camera:setPosition(cmx, cmy)
end
                 
function love.draw()
    camera:set()
    object.draw()
    camera:unset()
    loveframes.draw()
end
 
function love.mousepressed(x, y, button)
    object.mousepressed(x, y, button)
	creator.mousepressed(x, y, button)
    remover.mousepressed(x, y, button)
    loveframes.mousepressed(x, y, button)
end
 
function love.mousereleased(x, y, button)
    loveframes.mousereleased(x, y, button)
    object.mousereleased(x, y, button)
end
 
function love.keypressed(key, unicode)
    loveframes.keypressed(key, unicode) 
    if key == "tab" then
        frame:SetVisible(not frame:GetVisible())
    end
end
 
function love.keyreleased(key)
    loveframes.keyreleased(key) 
end

function love.textinput(text)
    loveframes.textinput(text)
end