
local creator = {}
creator.tabs = {
	[1] = {
		name = "Tools",
		object = loveframes.Create("panel")
	},
	[2] = {
		name = "Create",
		object = loveframes.Create("panel")
	},
	[3] = {
		name = "Statistics",
		object = loveframes.Create("panel")
	}
}

function col(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end


function creator.load()
	r, g, b = 0, 0, 0
	width, height = 1, 1
	radius = 1
	frame = loveframes.Create("frame")
	tabs = loveframes.Create("tabs", frame)
	clear = loveframes.Create("button", creator.tabs[1].object)
	create = loveframes.Create("button", creator.tabs[1].object)
	drag = loveframes.Create("button", creator.tabs[1].object)
	remove = loveframes.Create("button", creator.tabs[1].object)
	removeoff = loveframes.Create("button", creator.tabs[3].object)
	choice = loveframes.Create("multichoice", creator.tabs[2].object)
	errorpanel = loveframes.Create("panel")
	errortool = loveframes.Create("tooltip")
	rectangle = loveframes.Create("panel", creator.tabs[2].object)
	circle = loveframes.Create("panel", creator.tabs[2].object)
	rgb = loveframes.Create("panel", creator.tabs[2].object)
	objects = loveframes.Create("progressbar", creator.tabs[3].object)
	objtext = loveframes.Create("text", creator.tabs[3].object)
	rgbImage = loveframes.Create("image", rgb)
	rtext = loveframes.Create("text", rgb)
	gtext = loveframes.Create("text", rgb)
	btext = loveframes.Create("text", rgb)
	rbox = loveframes.Create("numberbox", rgb)
	gbox = loveframes.Create("numberbox", rgb)
	bbox = loveframes.Create("numberbox", rgb)
	static1 = loveframes.Create("checkbox", rectangle)
	static2 = loveframes.Create("checkbox", circle)
	width1 = loveframes.Create("text", rectangle)
	height1 = loveframes.Create("text", rectangle)
	radius1 = loveframes.Create("text", circle)
	slider1 = loveframes.Create("slider", rectangle)
	slider2 = loveframes.Create("slider", rectangle)
	slider3 = loveframes.Create("slider", circle)

	clear.OnClick = function()
		object.clear()
	end
	clear:SetText("Remove All")
	clear:SetPos(5, 5)

	create.OnClick = function()
		mode = "Create" 
	end
	create:SetText("Create")
	create:SetPos(5, 35)

	errorpanel:SetSize(15, 15)
	errorpanel.Draw = function() end

	errortool:SetObject(errorpanel)
	errortool:SetText("Error: Max Objects Reached")
	errorpanel:SetVisible(false)

	drag.OnClick = function()
		mode = "Drag" 
	end
	drag:SetText("Drag")
	drag:SetPos(5, 65)

	remove.OnClick = function()
		mode = "Remove" 
	end
	remove:SetText("Remove")
	remove:SetPos(5, 95)

	removeoff.OnClick = function()
		object.clearOffscreen()
	end
	removeoff:SetText("Remove Offscreen Objects")
	removeoff:SetPos(5, 55)
	removeoff:SetSize(165, 25)

	objects:SetMinMax(0, object.max)
	objects:SetPos(5, 25)
	objects:SetWidth(165)

	objtext:SetText("Objects")
	objtext:SetPos(5, 5)

	static1:SetText("Static")
	static1:SetPos(55, 140)

	static2:SetText("Static")
	static2:SetPos(55, 140)

	rgbImage:SetImage("img/RGB.png")
	rgbImage:SetPos(15, 15)
	rgbImage:SetScaleX(1.4)

	width1:SetPos(5, 5)
	height1:SetPos(5, 65)

	radius1:SetPos(5, 5)

	slider1:SetPos(5, 25)
	slider1:SetWidth(160)
	slider1:SetMinMax(1, 300)

	slider3:SetPos(5, 25)
	slider3:SetWidth(160)
	slider3:SetMinMax(1, 300)

	rbox:SetPos(45, 130)
	rbox:SetSize(75, 25)
	rbox:SetMinMax(0, 255)
	gbox:SetPos(45, 170)
	gbox:SetSize(75, 25)
	gbox:SetMinMax(0, 255)
	bbox:SetPos(45, 210)
	bbox:SetSize(75, 25)
	bbox:SetMinMax(0, 255)

	slider2:SetPos(5, 85)
	slider2:SetWidth(160)
	slider2:SetMinMax(1, 300)

	rectangle:SetPos(5, 45)
	rectangle:SetSize(170, 200)
	rectangle:SetVisible(false)

	circle:SetPos(5, 45)
	circle:SetSize(170, 200)
	circle:SetVisible(false)

	rgb:SetPos(5, 250)
	rgb:SetSize(170, 255)
	rgb:SetVisible(false)

	choice:AddChoice("Rectangle")
	choice:AddChoice("Circle")
	choice:SetPos(5, 5)
	choice:SetSize(170, 28)

	tabs:SetPos(5, 30)
	tabs:SetSize(190, 545)

    frame:SetName("Items")
    frame:SetResizable(false)
    frame:SetSize(200, 580)
    frame:SetPos(10, 10)
    frame:ShowCloseButton(false)
    frame:SetDraggable(false)
    for k, v in ipairs(creator.tabs) do
    	v.object.Draw = function() end
    	tabs:AddTab(v.name, v.object)
    end
end

function creator.update()
	errorpanel:SetPos(camera:mousePosition())
	if object.id == object.max then
		errorpanel:SetVisible(true)
	else errorpanel:SetVisible(false) end
	if frame:GetVisible() then
		if col(10, 10, 200, 580, love.mouse.getX(), love.mouse.getY(), 15, 15) then
			can = false
		else can = true end
	else can = true end
	objects:SetValue(object.id)
	r, g, b = rbox:GetValue(), gbox:GetValue(), bbox:GetValue()
	radius = slider3:GetValue()
	rgbImage:SetColor(r, g, b)
	width1:SetText("Width: " .. math.floor(slider1:GetValue()))
	height1:SetText("Height: " .. math.floor(slider2:GetValue()))
	radius1:SetText("Radius: " .. math.floor(slider3:GetValue()))
	if choice:GetChoice() == "Rectangle" then
		circle:SetVisible(false)
		rectangle:SetVisible(true)
		rgb:SetVisible(true)
	elseif choice:GetChoice() == "Circle" then
		rectangle:SetVisible(false) 
		circle:SetVisible(true)
		rgb:SetVisible(true)
	else
		rectangle:SetVisible(false) 
		circle:SetVisible(false)
		rgb:SetVisible(false)
	end
end

function creator.mousepressed(x, y, b)
	if mode == "Create" and can == true then
		if b == "l" then
			if object.id < object.max then
    			if choice:GetChoice() == "Rectangle" then
    				object.newRectangle(type1, x + camera._x, y + camera._y, slider1:GetValue(), slider2:GetValue())
    			elseif choice:GetChoice() == "Circle" then
    				object.newCircle(type2, x + camera._x, y + camera._y, slider3:GetValue())
    			end
    		end
   	 	end
   	end
end

return creator